---
title: Awesome Foal
---
A collection of official and unofficial libraries and resources about Foal.

## Packages

- [@foal/aws-s3](https://www.npmjs.com/package/@foal/aws-s3): handle file upload to AWS S3.
- [@foal/cli](https://www.npmjs.com/package/@foal/cli): commands to generate, build and run code.
- [@foal/graphql](https://www.npmjs.com/package/@foal/graphql): build GraphQL API.
- [@foal/graphiql](https://www.npmjs.com/package/@foal/graphiql): generate a GraphiQL interface.
- [@foal/jwks-rsa](https://www.npmjs.com/package/@foal/jwks-rsa): retrieve RSA signing keys from a JWKS endpoint.
- [@foal/jwt](https://www.npmjs.com/package/@foal/jwt): authenticate users with JWT.
- [@foal/mongodb](https://www.npmjs.com/package/@foal/mongodb): session store for MongoDB.
- [@foal/password](https://www.npmjs.com/package/@foal/password): hash, salt and check passwords.
- [@foal/redis](https://www.npmjs.com/package/@foal/redis): session store for redis.
- [@foal/social](https://www.npmjs.com/package/@foal/social): authenticate users with Facebook, Github, Google and LinkedIn.
- [@foal/storage](https://www.npmjs.com/package/@foal/storage): manage file upload and storage in local and in the Cloud.
- [@foal/swagger](https://www.npmjs.com/package/@foal/swagger): display a SwaggerUI page.
- [@foal/typeorm](https://www.npmjs.com/package/@foal/typeorm): session store for TypeORM.
- [@foal/typestack](https://www.npmjs.com/package/@foal/typestack): validate and unserialize requests with [class-transformer](https://www.npmjs.com/package/class-transformer) and [class-validator](https://www.npmjs.com/package/class-validator).
- [@codeperate/foalts-apischema-builder](https://www.npmjs.com/package/@codeperate/foalts-apischema-builder): build ApiSchema with builder pattern.

## Videos

- [FoalTS Tutorial Video Series by Alex Merced of AlexMercedCoder.com](https://youtu.be/c7vfkzVm4Y8)
- [Run unit tests with VSCode debugger](https://youtu.be/5S_XVaURK8k)
- [Read file metadata during upload](https://www.youtube.com/watch?v=8wiyS5_Usoc)
- [Beginner tutorial - How to create a simple to-do list](https://www.youtube.com/watch?v=kPDlHtgKk68)
- [How to manage configuration with FoalTS](https://www.youtube.com/watch?v=e_W8QnImazo)

## Articles

- [The official blog](https://foalts.org/blog)
- [FoalTS framework & OpenAPI = ❤](https://medium.com/@poullain.loic/foalts-framework-openapi-5ef3903d01af)
- [How to build a REST API with FoalTS](https://medium.com/@poullain.loic/how-to-build-a-rest-api-with-foalts-5fcd72d10a83)
- [How to add pagination in FoalTS ](https://dev.to/loicpoullain/how-to-add-pagination-in-foalts-2cef)

## Newsletter

- [The offical newsletter](https://foalts.org/newsletter)